import { ApolloError } from 'apollo-client';
import React from 'react';
import { MutationFn, MutationProps as ApolloMutationProps, OperationVariables } from 'react-apollo';
import { Omit } from './types';
interface Loading {
    type: 'loading';
}
interface Data<T> {
    type: 'data';
    data: T;
}
interface Error {
    type: 'error';
    error: ApolloError;
}
export declare type MutationResult<T> = Loading | Data<T> | Error;
export interface MutationProps<TData, TVariables> extends Omit<ApolloMutationProps<TData, TVariables>, 'children'> {
    children: (value: {
        mutateFn: MutationFn<TData, TVariables>;
        result: MutationResult<TData>;
    }) => React.ReactNode;
}
declare class Mutation<TData = any, TVariables = OperationVariables> extends React.PureComponent<MutationProps<TData, TVariables>> {
    render(): JSX.Element;
    private mapData;
}
export default Mutation;
