import { ApolloError } from 'apollo-client';
import React from 'react';
import { OperationVariables, QueryProps as ApolloQueryProps } from 'react-apollo';
import { Omit } from './types';
interface Loading {
    type: 'loading';
}
interface Data<T> {
    type: 'data';
    data: T;
}
interface Error {
    type: 'error';
    error: ApolloError;
}
export declare type QueryResult<T> = Loading | Data<T> | Error;
export interface QueryProps<TData, TVariables> extends Omit<ApolloQueryProps<TData, TVariables>, 'children' | 'notifyOnNetworkStatusChange'> {
    children: (value: {
        result: QueryResult<TData>;
    }) => React.ReactNode;
}
declare class Query<TData = any, TVariables = OperationVariables> extends React.PureComponent<QueryProps<TData, TVariables>> {
    render(): JSX.Element;
    private mapData;
}
export default Query;
