(function (global, factory) {
    typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('apollo-client'), require('react'), require('react-apollo')) :
    typeof define === 'function' && define.amd ? define(['exports', 'apollo-client', 'react', 'react-apollo'], factory) :
    (factory((global.TSApollo = {}),global.ApolloClient,global.React,global.ReactApollo));
}(this, (function (exports,apolloClient,React,reactApollo) { 'use strict';

    React = React && React.hasOwnProperty('default') ? React['default'] : React;

    /*! *****************************************************************************
    Copyright (c) Microsoft Corporation. All rights reserved.
    Licensed under the Apache License, Version 2.0 (the "License"); you may not use
    this file except in compliance with the License. You may obtain a copy of the
    License at http://www.apache.org/licenses/LICENSE-2.0

    THIS CODE IS PROVIDED ON AN *AS IS* BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
    KIND, EITHER EXPRESS OR IMPLIED, INCLUDING WITHOUT LIMITATION ANY IMPLIED
    WARRANTIES OR CONDITIONS OF TITLE, FITNESS FOR A PARTICULAR PURPOSE,
    MERCHANTABLITY OR NON-INFRINGEMENT.

    See the Apache Version 2.0 License for specific language governing permissions
    and limitations under the License.
    ***************************************************************************** */
    /* global Reflect, Promise */

    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };

    function __extends(d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    }

    var __assign = Object.assign || function __assign(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p)) t[p] = s[p];
        }
        return t;
    };

    var Query = /** @class */ (function (_super) {
        __extends(Query, _super);
        function Query() {
            var _this = _super !== null && _super.apply(this, arguments) || this;
            _this.mapData = function (result) {
                var loading = result.loading, error = result.error, data = result.data;
                if (loading) {
                    return { type: 'loading' };
                }
                if (error) {
                    return {
                        type: 'error',
                        error: error,
                    };
                }
                if (data) {
                    return {
                        type: 'data',
                        data: data,
                    };
                }
                // This point should actually never be reached due to the restrictions of Apollo GraphQL responses
                console.error('An unexpected Query sidecase happened where no valid union type could be found, please file an issue for this.');
                return { type: 'error', error: new apolloClient.ApolloError({}) };
            };
            return _this;
        }
        Query.prototype.render = function () {
            var _this = this;
            return (React.createElement(reactApollo.Query, __assign({}, this.props), function (data) { return _this.props.children({ result: _this.mapData(data) }); }));
        };
        return Query;
    }(React.PureComponent));

    var Mutation = /** @class */ (function (_super) {
        __extends(Mutation, _super);
        function Mutation() {
            var _this = _super !== null && _super.apply(this, arguments) || this;
            _this.mapData = function (result) {
                var loading = result.loading, error = result.error, data = result.data;
                if (loading) {
                    return { type: 'loading' };
                }
                if (error) {
                    return {
                        type: 'error',
                        error: error,
                    };
                }
                if (data) {
                    return {
                        type: 'data',
                        data: data,
                    };
                }
                // This point should actually never be reached due to the restrictions of Apollo GraphQL responses
                console.error('An unexpected Mutation sidecase happened where no valid union type could be found, please file an issue for this.');
                return { type: 'error', error: new apolloClient.ApolloError({}) };
            };
            return _this;
        }
        Mutation.prototype.render = function () {
            var _this = this;
            return (React.createElement(reactApollo.Mutation, __assign({}, this.props), function (mutateFn, data) {
                return _this.props.children({ mutateFn: mutateFn, result: _this.mapData(data) });
            }));
        };
        return Mutation;
    }(React.PureComponent));

    exports.Query = Query;
    exports.Mutation = Mutation;

    Object.defineProperty(exports, '__esModule', { value: true });

})));
